/******************************************************************************/
/* CD_BIND.H								      */
/******************************************************************************/

#ifndef	__HEADER_CD_BIND
#define	__HEADER_CD_BIND	__HEADER_CD_BIND

/* -------------------------------------------------------------------------- */
/* CD_DISP.C */

void	cd_display_title( GRECT * );
void	cd_select_title( void );

void	cd_display_info( GRECT * );
void	cd_disp_info( GRECT * );

void	cd_display_header( GRECT *);

void	cd_display( GRECT * );
void	cd_select( GRECT * );
void	cd_currsel( GRECT * );

void	cd_display_str( ITEM *, unsigned char * );
void	cd_display_color( ITEM * );
void	cd_display_framestr( unsigned long, unsigned char * );
void	cd_display_item( ITEM *, GRECT * );
void	cd_select_item( ITEM *, GRECT * );

long	cd_y_coordinate( ITEM * );
long	cd_inv_coordinate( long );

void	cd_select_all( void );
void	cd_deselect( void );

/* -------------------------------------------------------------------------- */
/* CD_DSPLD.C */

int	dsp_reloadprg( void );
int	dsp_loadprg( void );

/* -------------------------------------------------------------------------- */
/* CD_EDIT.C */

void	cd_dial_cdromtitle( void );
void	cd_add_comments( void );
void	cd_edit_filename( void );

void	cd_update_time( CDROM * );
void	cd_update_disp( void );

/* -------------------------------------------------------------------------- */
/* CD_COMND.C */

void	cd_comnd_emulate( void );

/* -------------------------------------------------------------------------- */
/* CD_FILE.C */

void	cd_free( CDROM * );

CDROM	*cd_create( void );
ITEM	*cd_create_item( unsigned int );

int	cd_save( CDROM *, FILE * );
CDROM	*cd_load( FILE *, int * );

int	cd_clipexport( FILE * );
int	cd_clipsave( FILE * );
CDROM	*cd_clipload( FILE *, int * );
void	cd_clipfree( CDROM * );

void	cd_save_filelist( void );

/* -------------------------------------------------------------------------- */
/* CD_INIT.C */

int	cd_initialise( void );

void	cd_set_parameters( void );
void	cd_set_windareas( void );

void	cd_redraw( GRECT * );
void	cd_wind_arrowed( int );
void	cd_wind_hslide( int );
void	cd_wind_vslide( int );

void	cd_scroll_v( long );
void	cd_scroll_h( long );

void	cd_set_vertslider( void );
void	cd_set_horzslider( void );

void	cd_scroll_disp( void );

void	cd_set_maxvisxy( void );
void	cd_visxy_update( void );

void	cd_setmenu_rest( void );
void	cd_setmenu_empty( void );
void	cd_setmenu_insert( void );
void	cd_setmenu_select( void );
void	cd_setmenu_undo( void );

/* -------------------------------------------------------------------------- */
/* CD_MENU.C */

void	cd_cut( void );
void	cd_copy( void );
void	cd_paste( void );
void	cd_delete( void );

void	cd_insert_session( void );
void	cd_insert_track( void );
void	cd_insert_file( void );

/* -------------------------------------------------------------------------- */
/* CD_PREF.C */

void	cd_init_preferences( void );
int	cd_save_preferences( FILE * );
int	cd_load_preferences( FILE * );

void	cd_set_logfilename( void );

void	cd_dial_latency( void );

void	cd_dial_preferences( void );

void	cd_dial_preloadpref( void );

/* -------------------------------------------------------------------------- */
/* CD_SCROL.C */

void	cd_key_pageup( void );
void	cd_key_pagedown( void );

void	cd_key_home( void );
void	cd_key_end( void );
void	cd_key_up( void );
void	cd_key_down( void );

void	cd_key_select( void );

void	cd_handle_button( int, int, int, int );

/* -------------------------------------------------------------------------- */
/* CD_SRCH.C */

void	cd_goto_session( void );
void	cd_goto_track( void );
void	cd_find( void );
void	cd_find_next( void );

/* -------------------------------------------------------------------------- */
/* CD_UNDO.C */

void	cd_undo_free( void );
int	cd_saveundo( void );
void	cd_undo( void );

/* -------------------------------------------------------------------------- */

#endif

/******************************************************************************/
/* End of CD_BIND.H							      */
/******************************************************************************/
