/******************************************************************************/
/* CD_MENU.C								      */
/******************************************************************************/

#include "st_def.h"
#include "st_struc.h"
#include "st_aes.h"
#include "cd_bind.h"

#include "cdmonusa.h"

/* -------------------------------------------------------------------------- */

extern	CDROM	*gl_actdocu;

extern	GRECT	cd_datarect;

extern	long	cd_visy;

/* -------------------------------------------------------------------------- */

int	cd_srchflag = FALSE;
unsigned char	cd_srchstrs[ MAX_SRCHSTRS ];

/* -------------------------------------------------------------------------- */

static	int	cd_find_str( void );

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

void	cd_goto_session()
{
register CDROM	*docu = gl_actdocu;
register ITEM	*item;
register unsigned char	*t;
register OBJECT	*Tree;
register int	Respons;
register int	sessno;
register int	i;
register long	liny;

	if (docu->NoSessions <= 0)
		return;

	Tree = st_objc_get_tree(GOTOSESS);
	strcpy((t = TePtext(GOSESSNO)), "0");

	st_objc_draw_tree(Tree);
	Respons = form_do(Tree, GOSESSNO);
	Tree[ Respons ].ob_state &= ~SELECTED;
	st_objc_erase_tree(Tree);

	if (Respons == GOSESSCN)
		return;

	sessno = atoi(t);
	if ((sessno < 0) || (sessno >= docu->NoSessions))
	{
		st_error_message_three(E_NOSESSION, sessno, 0, docu->NoSessions - 1);
		return;
	}

	i = 0;
	for (item = docu->FirstItem ; item ; item = item->next)
	{
		if (!(item->Settings & IT_SESSION))
			continue;

		if (i == sessno)
			break;
		i++;
	}
	liny = cd_y_coordinate(item) - item->Hite;
	cd_scroll_v(cd_visy - liny);

	cd_currsel(&cd_datarect);
	docu->SelItem = item;
	cd_currsel(&cd_datarect);
	cd_setmenu_insert();
	return;
}

/* -----------------------------------------------------------------------------
 */

void	cd_goto_track()
{
register CDROM	*docu = gl_actdocu;
register ITEM	*item;
register unsigned char	*t;
register OBJECT	*Tree;
register int	Respons;
register int	trakno;
register int	i;
register long	liny;

	if (docu->NoTracks <= 0)
		return;

	Tree = st_objc_get_tree(GOTOTRAK);
	strcpy((t = TePtext(GOTRAKNO)), "0");

	st_objc_draw_tree(Tree);
	Respons = form_do(Tree, GOTRAKNO);
	Tree[ Respons ].ob_state &= ~SELECTED;
	st_objc_erase_tree(Tree);

	if (Respons == GOTRAKCN)
		return;

	trakno = atoi(t);
	if ((trakno < 1) || (trakno > docu->NoTracks))
	{
		st_error_message_three(E_NOTRACK, trakno, 1, docu->NoTracks);
		return;
	}

	i = 0;
	for (item = docu->FirstItem ; item ; item = item->next)
	{
		if (!(item->Settings & IT_TRACK))
			continue;

		i ++;
		if (i == trakno)
			break;
	}

	liny = cd_y_coordinate(item) - item->Hite;
	cd_scroll_v(cd_visy - liny);

	cd_currsel(&cd_datarect);
	docu->SelItem = item;
	cd_currsel(&cd_datarect);
	cd_setmenu_insert();
	return;
}

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

static	int	cd_find_str()
{
register CDROM	*docu = gl_actdocu;
register ITEM	*item = docu->SelItem;
unsigned char	mess[ MAX_COMLEN ];
unsigned char	srchstrs[ MAX_SRCHSTRS ];

	strcpy(srchstrs, cd_srchstrs);
	st_str_toupper(srchstrs);

	item = item->next;
	if (item == NULL) item = docu->FirstItem;

	for (;;)
	{
		cd_y_coordinate(item);
		cd_display_str(item, mess);
		st_str_toupper(mess);
		if (strstr(mess, srchstrs))
			break;

		sprintf(mess, "%ld", item->Length);
		if (strstr(mess, srchstrs))
			break;

		cd_display_framestr(item->FrameStart, mess);
		if (strstr(mess, srchstrs))
			break;

		cd_display_framestr(item->FrameLength, mess);
		if (strstr(mess, srchstrs))
			break;

		strcpy(mess, item->Comments);
		st_str_toupper(mess);
		if (strstr(mess, srchstrs))
			break;

		if (item == docu->SelItem)
			return(FALSE);

		item = item->next;
		if (item == NULL) item = docu->FirstItem;
	}
	cd_currsel(&cd_datarect);
	docu->SelItem = item;
	cd_currsel(&cd_datarect);
	cd_scroll_disp();
	cd_setmenu_insert();
	cd_setmenu_empty();
	return(TRUE);
}

/* -----------------------------------------------------------------------------
 */

void	cd_find()
{
register CDROM	*docu = gl_actdocu;
register OBJECT	*Tree;
register int	Respons;

	if (docu->NoItems <= 0)
		return;

	Tree = st_objc_get_tree(CDRMFIND);
	strcpy(TePtext(CDFINDST), cd_srchstrs);

	st_objc_draw_tree(Tree);
	Respons = form_do(Tree, CDFINDST);
	Tree[ Respons ].ob_state &= ~SELECTED;
	st_objc_erase_tree(Tree);

	if (Respons == CDFINDCN)
		return;

	strcpy(cd_srchstrs, TePtext(CDFINDST));
	cd_srchflag = (strlen(cd_srchstrs) ? TRUE : FALSE);

	if (!cd_srchflag)
	{
		cd_setmenu_empty();
		return;
	}

	if (!cd_find_str())
	{
		st_error_message(E_STRNOTFOUND);
		cd_srchflag = FALSE;
	}
	return;
}

/* -----------------------------------------------------------------------------
 */

void	cd_find_next()
{
register CDROM	*docu = gl_actdocu;

	if (docu->NoItems <= 0)
		return;

	if (!cd_srchflag)
		return;

	cd_find_str();
	return;
}

/******************************************************************************/
/* End of CD_MENU.C							      */
/******************************************************************************/

