/******************************************************************************/
/* ST_AES.C								      */
/******************************************************************************/

#include "st_def.h"
#include "st_aes.h"

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

int	appl_getinfo(ap_gtype, ap_gout1, ap_gout2, ap_gout3, ap_gout4)
int	ap_gtype;
int	*ap_gout1, *ap_gout2, *ap_gout3, *ap_gout4;
{
	_AEScontrol[0] = 130;
	_AEScontrol[1] = 1;
	_AEScontrol[2] = 5;
	_AEScontrol[3] = 0;
	_AEScontrol[4] = 0;

	_AESintin[0] = ap_gtype;

	aes(_AESpb);

	(*ap_gout1) = _AESintout[1];
	(*ap_gout2) = _AESintout[2];
	(*ap_gout3) = _AESintout[3];
	(*ap_gout4) = _AESintout[4];
	return(_AESintout[0]);
}

/* -----------------------------------------------------------------------------
 */

int	appl_search(ap_smode, ap_sname, ap_stype, ap_sid)
int	ap_smode;
unsigned char	ap_sname[];
int	*ap_stype;
int	*ap_sid;
{
	_AEScontrol[0] = 18;
	_AEScontrol[1] = 1;
	_AEScontrol[2] = 3;
	_AEScontrol[3] = 1;
	_AEScontrol[4] = 0;

	_AESintin[0] = ap_smode;
	_AESaddrin[0] = ap_sname;

	aes(_AESpb);

	(*ap_stype) = _AESintout[1];
	(*ap_sid) = _AESintout[2];

	return(_AESintout[0]);
}

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 * Returns the pointer to a free string, gicven it's index
 */

unsigned char	*st_objc_get_string(index)
int	index;
{
long	*cp;

	rsrc_gaddr(15, index, &cp);
	return((unsigned char *)(*cp));
}

/* -----------------------------------------------------------------------------
 * Returns a pointer to a object tree, given it's index
 */

OBJECT	*st_objc_get_tree(index)
int	index;
{
OBJECT	*Tree;

	rsrc_gaddr(0, index, &Tree);
	return(Tree);
}

/* -----------------------------------------------------------------------------
 * Centers given object tree and returns it's rectangle
 */

void	st_objc_form_center(Tree, box)
OBJECT	*Tree;
register GRECT	*box;
{
	form_center(Tree, &(box->g_x), &(box->g_y), &(box->g_w), &(box->g_h));
	return;
}

/* -----------------------------------------------------------------------------
 * Calculates and saves the screen rectangle for the given object Tree
 * and draws it in the center of the screen
 */

void	st_objc_draw_tree(Tree)
register OBJECT	*Tree;
{
GRECT	box;

	st_mouse_free();
	st_objc_form_center(Tree, &box);

	form_dial(FMD_START, 1,1,1,1, box.g_x, box.g_y, box.g_w, box.g_h);
	form_dial(FMD_GROW, 1,1,1,1, box.g_x, box.g_y, box.g_w, box.g_h);

	objc_draw(Tree, ROOT, MAX_DEPTH, box.g_x, box.g_y, box.g_w, box.g_h);
	return;
}

/* -----------------------------------------------------------------------------
 * Erases the object Tree from the screen and redisplays the
 * screen rectangle, as requested
 */

void	st_objc_erase_tree(Tree)
register OBJECT	*Tree;
{
GRECT	box;

	st_objc_form_center(Tree, &box);

	form_dial(FMD_SHRINK, 1,1,1,1, box.g_x, box.g_y, box.g_w, box.g_h);
	form_dial(FMD_FINISH, 1,1,1,1, box.g_x, box.g_y, box.g_w, box.g_h);
	return;
}

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

void	st_evnt_waitforbuttonup()
{
int	mx, my, bstate, kstate;

	do
	{
		graf_mkstate(&mx, &my, &bstate, &kstate);

	} while (bstate);
	return;
}

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 * Routines to Hide/Show mouse.
 * To be called for each vdi display operation.
 */

void	st_mouse_hide()		{ graf_mouse(M_OFF     , 0L); return; }
void	st_mouse_show()		{ graf_mouse(M_ON      , 0L); return; }
void	st_mouse_flathand()	{ graf_mouse(FLAT_HAND , 0L); return; }
void	st_mouse_pointedhand()	{ graf_mouse(POINT_HAND, 0L); return; }
void	st_mouse_busy()		{ graf_mouse(BUSY_BEE  , 0L); return; }
void	st_mouse_free()		{ graf_mouse(ARROW     , 0L); return; }

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

void	st_boxtobox(from_box, to_box)
GRECT	*from_box;
register  GRECT	*to_box;
{
	to_box->g_x = from_box->g_x;
	to_box->g_y = from_box->g_y;
	to_box->g_w = from_box->g_w; 
	to_box->g_h = from_box->g_h; 
	return;
}

/* -----------------------------------------------------------------------------
 */

void	st_bartobox(bar, box)
register int	bar[];
register GRECT	*box;
{
	box->g_x = bar[0];
	box->g_y = bar[1];
	box->g_w = bar[2] - bar[0] + 1;
	box->g_h = bar[3] - bar[1] + 1;
	return;
}

/* -----------------------------------------------------------------------------
 */

void	st_boxtobar(box, bar)
GRECT	*box;
register int	bar[];
{
	bar[0] = box->g_x;
	bar[1] = box->g_y;
	bar[2] = box->g_x + box->g_w - 1;
	bar[3] = box->g_y + box->g_h - 1;
	return;
}

/* -----------------------------------------------------------------------------
 */

void	st_bartobar(a, b)
register int	a[], b[];
{
register int	i;

	for (i = 0 ; i < 4 ; i++)
	{
		b[i] = a[i];
	}
	return;
}

/* -----------------------------------------------------------------------------
 */

int	st_br_equal(a, b)
register int	a[], b[];
{
	if (	(a[0] == b[0]) && (a[1] == b[1]) &&
		(a[2] == b[2]) && (a[3] == b[3]))
	{
		return(TRUE);
	}
	return(FALSE);
}

/* -----------------------------------------------------------------------------
 * otherwise it returns NO & b2 may contain meaningless values.
 */

int	st_br_intersect(a, b)
register int	a[], b[];
{
GRECT	ar, br;

	st_bartobox(a, &ar);
	st_bartobox(b, &br);

	if (rc_intersect(&ar, &br))
	{
		st_boxtobar(&br, b);
		return(TRUE);
	}
	return(FALSE);
}

/* -----------------------------------------------------------------------------
 */

int	st_intersect(area, cliparea, box)
register GRECT	*area, *cliparea, *box;
{
	box->g_x = cliparea->g_x;
	box->g_y = cliparea->g_y;
	box->g_w = cliparea->g_w;
	box->g_h = cliparea->g_h;
	return(rc_intersect(area, box));
}

/* -----------------------------------------------------------------------------
 * This returns YES if the point (x, y) falls within the rectangle bar[] (the
 * boundaries inclusive) and return NO otherwise.
 */

int	st_isinbar(bar, x, y)
register int	bar[];
register int	x, y;
{
	if ((x < bar[0]) || (x > bar[2]) || (y < bar[1]) || (y > bar[3]))
	{
		return(FALSE);
	}
	return(TRUE);
}

/******************************************************************************/
/******************************************************************************/

/* This variable is used to help electric sliding when the user
 * clicks on the slider box and drags it along the slider
 */
static	int	listdial_slide_bstate = 0x0000;
static	int	listdial_slide_obj;

static	int	listdial_slide_old;
static	int	listdial_slide_min;
static	int	listdial_slide_max;
static	int	listdial_slide_lim;
static	int	listdial_slide_off;

static	int	listdial_slide_dir;

/* -----------------------------------------------------------------------------
 */

void	st_listdial_init(Tree, obj)
register OBJECT	*Tree;
register int	obj[];
{
register int	i;

	for (i = 0 ; obj[i] != -1 ; i++)
	{
		strcpy(TePtext(obj[i]), "");

		Tree[ obj[i] ].ob_flags &= ~TOUCHEXIT;
		Tree[ obj[i] ].ob_state = DISABLED;
	}
	return;
}

/* -----------------------------------------------------------------------------
 */

int	st_listdial_form_do(Tree, edit_obj)
OBJECT	*Tree;
int	edit_obj;
{
	return((listdial_slide_bstate & 0x0001) ? listdial_slide_obj : form_do(Tree, edit_obj));
}

/* -----------------------------------------------------------------------------
 * Routine to handle the scrolling in a item selector window of a dialog box
 * (such as the font/size dialog box )
 *
 * Tree	  : The object tree containing the item selector window
 * button : The button clicked
 * obj	  : The object name list of all the items of the scroll bar
 * index  : The current starting position of the items in the window
 * maxno  : Maximum number of items available for scrolling
 * items  : Maximum number of items which can be displayed at a time
 * tag	  : If less then one then no scrolling possible
 *
 * This routine returns the difference by which the scrolling has to be done
 */

long	st_listdial_scroll(Tree, button, obj, index, maxno, items, tag)
register OBJECT	*Tree;
register int	button;
register int	obj[];
register long	index;
long	maxno;
register int	items;
int	tag;
{
register long	maxindex;
register long	oldindex;
int	dirflag;
int	junk;

	if (tag < 0)
		return(0);

	maxindex = maxno - items;
	if (maxindex <= 0)
		return(0);

	oldindex = index;
	dirflag = ((Tree[ obj[2] ].ob_x == Tree[ obj[3] ].ob_x) ? TRUE : FALSE);

	listdial_slide_obj = button;
	if ((button == obj[2]) || (button == obj[3]))
	{
		GRECT	box;

		st_objc_form_center(Tree, &box);
		if (!(listdial_slide_bstate & 0x0001))
		{
			Tree[ button ].ob_state |= SELECTED;
			objc_draw(Tree, button, MAX_DEPTH, box.g_x, box.g_y, box.g_w, box.g_h);
		}
		graf_mkstate(&junk, &junk, &listdial_slide_bstate, &junk);
		if (!(listdial_slide_bstate & 0x0001))
		{
			Tree[ button ].ob_state &= ~SELECTED;
			objc_draw(Tree, button, MAX_DEPTH, box.g_x, box.g_y, box.g_w, box.g_h);
		}
	}

	if (button == obj[0])
	{
		if (listdial_slide_bstate & 0x0001)
		{
			graf_mkstate(&junk, &junk, &listdial_slide_bstate, &junk);
			if (!(listdial_slide_bstate & 0x0001))
				return(0);
		}
		else
		{
			int	xx, yy;
			int	objxx, objyy;

			graf_mkstate(&xx, &yy, &listdial_slide_bstate, &junk);
			objc_offset(Tree, obj[1], &objxx, &objyy);

			if (dirflag)
				listdial_slide_dir = ((yy < objyy) ? TRUE : FALSE);
			else	listdial_slide_dir = ((xx < objxx) ? TRUE : FALSE);
		}
		index += (listdial_slide_dir ? -items : items);
	}
	else if (button == obj[1])
	{
		int	xx, yy;
		int	pos, diff, act_diff;

		if (listdial_slide_bstate & 0x0001)
		{
			graf_mkstate(&xx, &yy, &listdial_slide_bstate, &junk);
			if (!(listdial_slide_bstate & 0x0001))
				return(0);
		}
		else
		{
			int	objxx, objyy;
			int	bar[4];

			graf_mkstate(&xx, &yy, &listdial_slide_bstate, &junk);

			objc_offset(Tree, obj[0], &bar[0], &bar[1]);
			bar[2] = bar[0] + Tree[ obj[0] ].ob_width - 1;
			bar[3] = bar[1] + Tree[ obj[0] ].ob_height - 1;

			if ((xx < bar[0]) || (yy < bar[1]) || (xx > bar[2]) || (yy > bar[3]))
				return(0);

			objc_offset(Tree, obj[1], &objxx, &objyy);
			if (dirflag)
			{
				diff = yy - objyy;

				listdial_slide_old = yy;
				listdial_slide_min = bar[1];
				listdial_slide_max = bar[3]- Tree[ obj[1] ].ob_height;
				listdial_slide_off = Tree[ obj[0] ].ob_height - Tree[ obj[1] ].ob_height;
			}
			else
			{
				diff = xx - objxx;

				listdial_slide_old = xx;
				listdial_slide_min = bar[0];
				listdial_slide_max = bar[2] - Tree[ obj[1] ].ob_width;
				listdial_slide_off = Tree[ obj[0] ].ob_width - Tree[ obj[1] ].ob_width;
			}

			listdial_slide_min += diff;
			listdial_slide_max += diff;
			listdial_slide_lim = listdial_slide_max - listdial_slide_min;
			listdial_slide_off = (int)((double)listdial_slide_off / (double)maxindex + 0.5);
		}
		pos = (dirflag ? yy : xx);
		act_diff = pos - listdial_slide_old;

		if (pos < listdial_slide_min)	pos = listdial_slide_min;
		if (pos > listdial_slide_max)	pos = listdial_slide_max;

		diff = pos - listdial_slide_old;
		listdial_slide_old = pos;

		pos = (dirflag ? Tree[ obj[1] ].ob_y : Tree[ obj[1] ].ob_x) + diff;
		index = (int)((((double)maxindex * (double)pos) / (double)listdial_slide_lim) + 0.5);
		if (index == oldindex)
		{
			index += (act_diff / listdial_slide_off);
		}
	}
	else if (button == obj[2])
	{
		index --;
	}
	else if (button == obj[3])
	{
		index ++;
	}
	else
	{
		return(0);
	}

	if (index < 0)		index = 0;
	if (index > maxindex)	index = maxindex;

	return(index - oldindex);
}

/* -----------------------------------------------------------------------------
 * This routine the click on any of the items inside the item selector window
 * button : the button clicked
 * obj	  : the object name list of the item holders in the item window
 *
 * If clicked on any of the items then it returns the number of item clicked
 * from the top of the item selector window, otherwise it returns -1
 */

int	st_listdial_select(button, obj)
register int	button;
register int	obj[];
{
register int	i;

	for (i = 0 ;; i++)
	{
		if (obj[i] == -1)	return(-1);
		if (button == obj[i])	return(i);
	}
}

/* -----------------------------------------------------------------------------
 * Update the slider position in the given item selector window of the given
 * dialog box
 */

void	st_listdial_updslider(Tree, obj, index, maxnos, items)
register OBJECT	*Tree;
register int	obj[];
register long	index;
register long	maxnos;
register int	items;
{
GRECT	oldbox, newbox;

	objc_offset(Tree, obj[1], &oldbox.g_x, &oldbox.g_y);
	oldbox.g_x --;
	oldbox.g_y --;
	oldbox.g_w = Tree[ obj[1] ].ob_width + 2;
	oldbox.g_h = Tree[ obj[1] ].ob_height + 2;

	st_listdial_setslider(Tree, obj, index, maxnos, items);

	objc_offset(Tree, obj[1], &newbox.g_x, &newbox.g_y);
	newbox.g_x --;
	newbox.g_y --;
	newbox.g_w = Tree[ obj[1] ].ob_width + 2;
	newbox.g_h = Tree[ obj[1] ].ob_height + 2;

	objc_draw(Tree, obj[0], MAX_DEPTH, oldbox.g_x, oldbox.g_y, oldbox.g_w, oldbox.g_h);
	objc_draw(Tree, obj[0], MAX_DEPTH, newbox.g_x, newbox.g_y, newbox.g_w, newbox.g_h);

	return;
}

/* -----------------------------------------------------------------------------
 * Update the slider position in the given item selector window of the given
 * dialog box
 */

void	st_listdial_setslider(Tree, obj, index, maxno, items)
register OBJECT	*Tree;
register int	obj[];
register long	index;
register long	maxno;
register int	items;
{
register int	omax;
register int	tmax;
int	smax;
int	tpos;
int	dirflag;
int	junk;

	dirflag = ((Tree[ obj[2] ].ob_x == Tree[ obj[3] ].ob_x) ? TRUE : FALSE);
	if (dirflag)
		graf_handle(&junk, &junk, &junk, &smax);
	else	graf_handle(&junk, &junk, &smax, &junk);

	tmax = (dirflag ? Tree[ obj[0] ].ob_height : Tree[ obj[0] ].ob_width);
	tpos = 0;

	if (maxno > items)
	{
		omax = tmax;
		tmax = (int)((((double)omax / (double)maxno) * (double)items) + 0.5);
		if (tmax < smax)
			tmax = smax;

		tpos = (int)((((double)(omax - tmax) / (double)(maxno - items)) * (double)index) + 0.5);
	}

	if (dirflag)
	{
		Tree[ obj[1] ].ob_y = tpos;
		Tree[ obj[1] ].ob_height = tmax;
	}
	else
	{
		Tree[ obj[1] ].ob_x = tpos;
		Tree[ obj[1] ].ob_width = tmax;
	}
	return;
}

/******************************************************************************/
/* End of ST_AES.C							      */
/******************************************************************************/
