/******************************************************************************/
/* ST_AES.H								      */
/******************************************************************************/

#ifndef	__HEADER_ST_MULTITOS
#define	__HEADER_ST_MULTITOS	__HEADER_ST_MULTITOS

/* -------------------------------------------------------------------------- */

/* some dummy macros for standard classes */

#define	WORD	int
#define	LONG	long

/* AES system trap */
/* --------------- */
/* ----	move.l	(sp),a1
	move.l	#$c8,d0
	trap	#2
---- */

int	aes( void ** );
#pragma	inline	d0 = aes() { register d0,d1,d2,a0,a1,a2; "2217203c000000c84e42"; }

/* AES version numbers */

#define	VERSION_AES_ROMTOS	0x0120
#define	VERSION_AES_BLITTERTOS	0x0120
#define	VERSION_AES_RAINBOWTOS	0x0140
#define	VERSION_AES_STETOS	0x0140

#define	VERSION_AES_TTTOS	0x0320
#define	VERSION_AES_FALCONTOS	0x0330

#define	VERSION_AES_MULTITOS400	0x0400
#define	VERSION_AES_MULTITOS410	0x0410

/* some aes bindings */

WORD	appl_search( int, unsigned char *, int *, int * );
WORD	appl_getinfo( int, int *, int *, int *, int * );

/* aes messages */

#define	WM_UNTOPPED	30
#define	WM_ONTOP	31

#define	AP_TERM		50
#define	AP_TFAIL	51
#define	AP_RESCHG	52
#define	SHUT_COMPLETED	60
#define	RESCH_COMPLETED	61

#define	AP_DRAGDROP	63

#define	SH_WDRAW	72
#define	CH_EXIT		80

/* new mouse form codes */

#define	MOUSE_SAVECURRENT	258
#define	MOUSE_RESTORELAST	259
#define	MOUSE_RESTOREPREV	260

/* submenu structures */

typedef	struct	_menu
	{
	OBJECT	*mn_tree;	/* the object tree of the menu */
	WORD	mn_menu;	/* the parent object of the menu items */
	WORD	mn_item;	/* the starting menu item */
	WORD	mn_scroll;	/* the scroll field status of the menu
				 * 0  : The menu will not scroll
				 * !0 : The menu will scroll if teh number
				 *      of menu items exceed the menu scroll
				 *      height. The non-zero value is the
				 *      object at which scrolling will begin.
				 *      this will allow one to have a menu in
				 *      which the scrollable region is only a
				 *      part of the whole menu.  The value must
				 *      be a menu item in the menu.
				 *
				 *	menu_settings can be used to change
				 *      the menu scroll height.
				 *
				 * NOTE : If the scroll field status is !0, the
				 *        menu items must consist entirely of
				 *        G_STRINGS.
				 */
	WORD	mn_keystate;	/* the CTRL,ALT,SHIFT key state at the time the
				 * mouse button was pressed.
				 */

	} MENU;

/* different delays for the submenu operations */
/* this structure is used with menu_settings */

typedef	struct	_mn_set
	{
	LONG	Display;	/* the submenu display delay */
	LONG	Drag;		/* the submenu drag delay */
	LONG	Delay;		/* the single click scroll delay */
	LONG	Speed;		/* the continuous scroll delay */
	WORD	Height;		/* the menu scroll height */

	} MN_SET;

/* the popup-menu and sub-menu function prototypes */

WORD	menu_popup( MENU *, WORD, WORD, MENU * );
WORD	menu_attach( WORD, OBJECT *, WORD, MENU * );
WORD	menu_istart( WORD, OBJECT *, WORD, WORD );
WORD	menu_settings( WORD, MN_SET * );

/* ICONIFYING WINDOW AND APPLICATION */

#define	SMALLER			0x4000

/* new window message events */

#define	WM_BOTTOMED		33

#define	WM_ICONIFY		34
#define	WM_UNICONIFY		35
#define	WM_ALLICONIFY		36

/* new wind_set/get calls */

#define	WF_BOTTOM		25

#define	WF_ICONIFY		26
#define	WF_UNICONIFY		27
#define	WF_UNICONIFYXYWH	28

/* -------------------------------------------------------------------------- */

#endif

/******************************************************************************/
/******************************************************************************/

#ifndef	__HEADER_ST_AES
#define	__HEADER_ST_AES		__HEADER_ST_AES

/* -------------------------------------------------------------------------- */

unsigned char	*st_objc_get_string( int );
OBJECT	*st_objc_get_tree( int );

void	st_objc_form_center( OBJECT *, GRECT * );
void	st_objc_draw_tree( OBJECT * );
void	st_objc_erase_tree( OBJECT * );

void	st_evnt_waitforbuttonup( void );

void	st_mouse_hide( void );
void	st_mouse_show( void );
void	st_mouse_flathand( void );
void	st_mouse_pointedhand( void );
void	st_mouse_busy( void );
void	st_mouse_free( void );

void	st_boxtobox( GRECT *, GRECT * );
void	st_bartobox( int *, GRECT * );
void	st_boxtobar( GRECT *, int * );
void	st_bartobar( int *, int * );
int	st_br_equal( int *, int * );
int	st_br_intersect( int *, int * );
int	st_intersect( GRECT *, GRECT *, GRECT * );
int	st_isinbar( int *, int, int );

void	st_listdial_init( OBJECT *, int * );
int	st_listdial_form_do( OBJECT *, int );
long	st_listdial_scroll( OBJECT *, int, int *, long, long, int, int );
int	st_listdial_select( int, int * );
void	st_listdial_updslider( OBJECT *, int *, long, long, int );
void	st_listdial_setslider( OBJECT *, int *, long, long, int );

/* -------------------------------------------------------------------------- */

#endif

/******************************************************************************/
/* End of ST_AES.H							      */
/******************************************************************************/
