/******************************************************************************/
/* ST_DEF.H								      */
/******************************************************************************/

#ifndef	__HEADER_ST_DEF
#define	__HEADER_ST_DEF		__HEADER_ST_DEF

/* -------------------------------------------------------------------------- */

#include <aes.h>
#include <errno.h>
#include <float.h>
#include <math.h>
#include <m68881.h>
#include <oserr.h>
#include <setjmp.h>
#include <stddef.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <tos.h>
#include <vdi.h>

#include <sys\types.h>
#include <sys\stat.h>

/******************************************************************************/
/******************************************************************************/

/* -------------------------------------------------------------------------- */

/* Some useful macro definitions, used throughout */

/* -------------------------------------------------------------------------- */

#ifndef	GLOBAL_TYPE_MACROS
#define	GLOBAL_TYPE_MACROS 1

#define	WP	1
#define	SS	2
#define	DB	3
#define	COM	4
#define	CLP	5

#endif

/* -------------------------------------------------------------------------- */

#ifndef	DESKTOP
#define	DESKTOP		0
#endif

/* -------------------------------------------------------------------------- */

#ifndef	NULL
#define	NULL	(char *)0L
#endif

#ifndef	TRUE
#define	TRUE	1
#endif

#ifndef	FALSE
#define	FALSE	0
#endif

#ifndef	ON
#define	ON	1
#endif

#ifndef	OFF
#define	OFF	0
#endif

#ifndef	YES
#define	YES	1
#endif

#ifndef	NO
#define	NO	0
#endif

/* -------------------------------------------------------------------------- */

#ifndef	NUL
#define	NUL		0x00
#endif

#ifndef	SOH
#define	SOH		0x01
#endif

#ifndef	BLANK
#define	BLANK		0x20
#endif

#ifndef	TAB
#define	TAB		0x09
#endif

#ifndef	LINEFEED
#define	LINEFEED	0x0A
#endif

#ifndef	CAR_RET
#define	CAR_RET		0x0D
#endif

/* -------------------------------------------------------------------------- */

#ifndef	INCH_TO_CMS
#define	INCH_TO_CMS	2.54
#endif

/* -------------------------------------------------------------------------- */

#ifndef	TePtext
#define	TePtext(y)  (unsigned char *)((TEDINFO *)Tree[(y)].ob_spec)->te_ptext
#endif

#ifndef	TePtmplt
#define	TePtmplt(y) (unsigned char *)((TEDINFO *)Tree[(y)].ob_spec)->te_ptmplt
#endif

/* -------------------------------------------------------------------------- */
/* Function key macro definitions  */

#define	MAX_FUNCTION_KEYS	20

/* -------------------------------------------------------------------------- */

#ifndef	MAX_NOWINDOWS
#define	MAX_NOWINDOWS	256
#endif

#ifndef	MAX_PATHNAME
#define	MAX_PATHNAME	128
#endif

#ifndef MAX_FILENAME
#define	MAX_FILENAME	14
#endif

#ifndef	MAX_TITLENAME
#define	MAX_TITLENAME	MAX_PATHNAME + 20
#endif

#ifndef	MAX_DEFNAME
#define	MAX_DEFNAME	34
#endif

#ifndef	MAX_MACRONAME
#define	MAX_MACRONAME	34
#endif

#ifndef	MAX_PICTNAME
#define	MAX_PICTNAME	34
#endif

#ifndef	MAX_STRLEN
#define	MAX_STRLEN	256
#endif

/* -------------------------------------------------------------------------- */

#ifndef	MAX_NO_PRNDRIVERS
#define	MAX_NO_PRNDRIVERS	10
#endif

#ifndef	MAX_PRNDRIVERNAME
#define	MAX_PRNDRIVERNAME	34
#endif

/* -------------------------------------------------------------------------- */

#ifndef	MAX_ST_FONTS
#define	MAX_ST_FONTS		256
#endif

#ifndef	MAX_FONTNAME
#define	MAX_FONTNAME		34
#endif

#ifndef	FSS_BUF_LEN
#define	FSS_BUF_LEN		8
#endif

#ifndef	FSS_MAX_SIZE
#define	FSS_MAX_SIZE		144
#endif

#ifndef	FSS_MIN_SIZE
#define	FSS_MIN_SIZE		1
#endif

#ifndef FNT_PRECISION
#define	FNT_PRECISION		16384L
#endif

/* Macros to be used with font/size/style specifications */

#define	FSS_MAX_STYLES		7

#define	FSS_DEFINE_NONE		0x00

#define	FSS_DEFINE_FONT		0x01
#define	FSS_DEFINE_SIZE		0x02
#define	FSS_DEFINE_STYLE	0x04
#define	FSS_DEFINE_ALL		0x07

/* Macros for different styles */

#ifndef	NORMAL
#define	NORMAL			0x0000
#endif

#ifndef	BOLD
#define	BOLD			0x0001
#endif

#ifndef	LIGHT
#define	LIGHT			0x0002
#endif

#ifndef	ITALIC
#define	ITALIC			0x0004
#endif

#ifndef	UNDERLINE
#define	UNDERLINE		0x0008
#endif

#ifndef	OUTLINE
#define	OUTLINE			0x0010
#endif

#ifndef	SHADOW
#define	SHADOW			0x0020
#endif

#ifndef	SUPERSCRIPT
#define	SUPERSCRIPT		0x0040
#endif

#ifndef	SUBSCRIPT
#define	SUBSCRIPT		0x0080
#endif

#ifndef	DOTTED_ULINE
#define	DOTTED_ULINE		0x0100
#endif

#ifndef	DOUBLE_ULINE
#define	DOUBLE_ULINE		0x0200
#endif

#ifndef	WORD_ULINE
#define	WORD_ULINE		0x0400
#endif

/* -------------------------------------------------------------------------- */

#ifndef	CHAR_FSS
#define	CHAR_FSS	0x00
#endif

#ifndef	CHAR_MAILPH
#define	CHAR_MAILPH	0x01
#endif

#ifndef	CHAR_TAB
#define	CHAR_TAB	0x09
#endif

#ifndef	CHAR_LF
#define	CHAR_LF		0x0A
#endif

#ifndef	CHAR_CR
#define	CHAR_CR		0x0D
#endif

#ifndef	CHAR_SPACE
#define	CHAR_SPACE	0x20
#endif

/* -------------------------------------------------------------------------- */

#ifndef	MAX_LINE_SPACE
#define	MAX_LINE_SPACE	255
#endif

/* -------------------------------------------------------------------------- */

#ifndef	MAX_DB_FIELDS
#define	MAX_DB_FIELDS	64
#endif

/* -------------------------------------------------------------------------- */

#define	ST_MIN_YEAR		1900
#define	ST_MAX_YEAR		2100
#define	ST_MAX_YEAR_SHORT	200

#define	ST_OLD_MIN_YEAR		1980

/* -------------------------------------------------------------------------- */

#define	WIND_REDRAW_NONE	2
#define	WIND_REDRAW_ALL		1
#define	WIND_REDRAW_OTHERS	0

/******************************************************************************/
/******************************************************************************/

/* -------------------------------------------------------------------------- */

/* Keyboard shift key status : for Lattice C */

#define	Getshift(x)	(unsigned int)Kbshift(x);

/* -------------------------------------------------------------------------- */

#include "st_error.h"
#include "st_str.h"
#include "st_vdi.h"

/* -------------------------------------------------------------------------- */

#endif

/******************************************************************************/
/* End of ST_DEF.H							      */
/******************************************************************************/
