/******************************************************************************/
/* ST_DIAL.C								      */
/******************************************************************************/

#include "st_def.h"
#include "st_aes.h"
#include "st_dial.h"

#include "cdmonusa.h"

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */
#define	NO_ITEMS	 6

long	st_dial_list(which, title, s, maxno)
int	which;
int	title;
register unsigned char	*s[];
long	maxno;
{
static	int	SlideRsc[] = { LISTSLID, LISTBOX, LISTUP, LISTDOWN };
static	int	FuncRsc[] = { LSTNAME1, LSTNAME2, LSTNAME3, LSTNAME4, LSTNAME5, LSTNAME6, -1};

register OBJECT	*Tree;
register int	i;
register long	j;
register long	ind;
register long	oldind;
register long	sel;
long	diff;
int	Respons;
int	DoubleClick;
GRECT	box;

/* initialise the list dialog box */

	Tree = st_objc_get_tree(DIALLIST);
	st_objc_form_center(Tree, &box);

	st_listdial_init(Tree, FuncRsc);
	Tree[ LISTBOX ].ob_y = 0;
	strcpy((unsigned char *)Tree[ LISTTITL ].ob_spec, st_freestr(title));

	if (which)
		Tree[ LISTCANL ].ob_flags &= ~HIDETREE;
	else	Tree[ LISTCANL ].ob_flags |=  HIDETREE;

/* draw the list dial and handle user actions */

	st_objc_draw_tree(Tree);

	for (sel = 0, ind = 0, oldind = -1 ;;)
	{
		if (ind != oldind)
		{
			st_listdial_init(Tree, FuncRsc);

			for (i = 0, j = ind ; (i < NO_ITEMS) && (j < maxno) ; i++, j++)
			{
				st_str_ncpy(TePtext(FuncRsc[i]), s[j], 31);

				Tree[ FuncRsc[i] ].ob_state = NORMAL;
				if (which)
				{
					Tree[ FuncRsc[i] ].ob_flags |= (TOUCHEXIT | SELECTABLE | RBUTTON);
					if (j == sel)
					{
						Tree[ FuncRsc[i] ].ob_state = SELECTED;
					}
				}
				else
				{
					Tree[ FuncRsc[i] ].ob_flags &= ~(TOUCHEXIT | SELECTABLE | RBUTTON);
				}
			}

			objc_draw(Tree, LISTPARA, MAX_DEPTH, box.g_x, box.g_y, box.g_w, box.g_h);
			st_listdial_updslider(Tree, SlideRsc, ind, maxno, NO_ITEMS);
			oldind = ind;
		}

		Respons = st_listdial_form_do(Tree, -1);
		DoubleClick = (Respons & 0x8000);
		Respons &= 0x7FFF;

		if ((Respons == LISTOK) || (Respons == LISTCANL))
		{
			Tree[ Respons ].ob_state &= ~SELECTED;
			break;
		}
		if (diff = st_listdial_scroll(Tree, Respons, SlideRsc, ind, maxno, NO_ITEMS, 1))
		{
			ind += diff;
			continue;
		}
		if (!which)
		{
			continue;
		}
		if ((diff = st_listdial_select(Respons, FuncRsc)) >= 0)
		{
			sel = ind + diff;

			if (DoubleClick)
			{
				break;
			}
			continue;
		}
	}

	st_objc_erase_tree(Tree);
	return((Respons == LISTCANL) ? -1 : sel);
}

/******************************************************************************/
/* End of ST_DIAL.C							      */
/******************************************************************************/

